clear all;
close all;
clc;
load dados.dat;
t = dados(:,1);     % tempo (s)
w = dados(:,2);     % velocidade angular (rad/s)
figure (1)
plot(t,w)

%t=(0:1/3000:(0.2-1/3000));
Ts = 1/3000 ;%taxa de amostragem
%defining object: motor
motor = iddata;
motor.Tstart = 0;
motor.Ts = Ts;
motor.InputData = 12*ones(size(t));
motor.OutputData = w;
%chamar a interface grfica 
%ident
%importar dados via objeto definido acima como 'motor'
% escolher modelo de processos e executar o comando 'Estimate'
%salvar a seo: motorid.sid

%Pode-se chamar a interface  grfica a partir de uma seo salva 
% aqui chamada 'motorid.sid' da seguinte forma:

%ident('motorid.sid')
va=9;
ktg= 0.153;
ka=1.23;
kat=0.424;
km = 10.912;                    
Tp1 = 0.015367;                   
Tp2 = 0.0022062;
nump=km;
denp=conv([Tp1 1],[Tp2 1]);
G=tf(ka*nump,denp);
F=tf(9,1);
H=tf(kat*ktg,1);
% especificao 
%ts = 0,04361s

numc=66.1*[0.012 1];
denc=[1 0];
Cc=tf(numc,denc);
[A,B,C,D]=linmod('motorMF');
Tss=ss(A,B,C,D);
Tf=tf(Tss);
p=pole(Tf);
z=zero(Tf);

%anlise ruido
wnovo=dados(400:600,2);tnovo=dados(400:600,1);
novosinal=wnovo-mean(wnovo);
L = size(tnovo,1);
NFFT = 2^nextpow2(L);
y = fft(novosinal,NFFT)/L;%plotar o espectro de freqncia do novosinal, obter a freqncia
 Pyy=y.*conj(y)/NFFT;
 f = 1/Ts*(0:NFFT/2)/NFFT;% gera vetor de frequencias; 
 %ts  o perodo de amostragem
% e usar o comando
figure (2)
 plot(f,Pyy(1:NFFT/2+1),'r-','LineWidth',2);
 [m i]=max(Pyy);
sinalruido=sin(2*pi*f(i))+var(novosinal)*randn(L);
figure(3)
  plot(sinalruido);  
        

